// select all elements
const start = document.getElementById("start");
const quiz = document.getElementById("quiz");
const question = document.getElementById("question");
const qImg = document.getElementById("qImg");
const choiceA = document.getElementById("A");
const choiceB = document.getElementById("B");
const choiceC = document.getElementById("C");
const counter = document.getElementById("counter");
const timeGauge = document.getElementById("timeGauge");
const progress = document.getElementById("progress");
const scoreDiv = document.getElementById("scoreContainer");
const restart = document.getElementById("restart");
const ELRF = document.getElementById("ELRF");
const ELU = document.getElementById("ELU");
const TLU = document.getElementById("TLU");
const REGE = document.getElementById("REGE");
const mainTitle = document.getElementById("mainTitle");
const info1 = document.getElementById("info1");
const info2 = document.getElementById("info2");

// create our questions
let questions = [
    {
		//#0
        question : "Millises valdkonnas töötades on sooline palgalõhe kõige suurem?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Ehitus",
        choiceB : "Finants- ja kindlustustegevus",
        choiceC : "Põllumajandus, metsamajandus",
        correct : "B"
    },{
        question : "Paju teenis Eestis naine iga mehe teenitud euro kohta?",
        imgSrc : "img/woman.jpeg",
        choiceA : "0.74 eurot",
        choiceB : "0.83 eurot",
        choiceC : " 0.68 eurot",
        correct : "A"
    },{
        question : "Mitu protsenti meestest jäävad Eestis lapsepuhkusele?",
        imgSrc : "img/woman.jpeg",
        choiceA : "7%",
        choiceB : "12%",
        choiceC : "alla 3%",
        correct : "C"
    },{
        question : "Kuidas hinnatakse palgalõhe protsendi suurust?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Brutopalkade vahe protsentides",
        choiceB : "Netopalkade vahe protsentides",
        choiceC : "Ühes leibkonnas meeste ja naiste palkade vahe",
        correct : "A"
    },{
        question : "Millistes nimetatud valdkondades teenivad naised meestest rohkem?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Tervisehoid",
        choiceB : "Kultuur- ja loometegevus",
        choiceC : "Juhid reklaami ja suhtekorralduse alal",
        correct : "C"
    },{
		//#5
        question : "Kui suur on keskmine palgalõhe Euroopas?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Umbes 16%",
        choiceB : "Umbes 30%",
        choiceC : "Umbes 9%",
        correct : "A"
    },{
        question : "Miks erinevad andmed palgalõhe kohta Eestis Statistikaameti ja Eurostati uuringute vahel?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Statistikaamet arvestab netopalkade vahet protsentides, samas kui Eurostat arvestab brutopalkade vahet protsentides",
        choiceB : "Euroopa Liidu uuringud ei võta arvesse ettevõtteid, kus on alla 10 töötaja või teatud ametialasid (põllumajandus, metsamajandus, kalapüük)",
        choiceC : "Neid ei ole tehtud kunagi sama aasta kohta ehk ei ole võrreldavad",
        correct : "B"
    },{
        question : "Millistest teguritest võib tulla selgitamata sooline palgalõhe?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Naiste diskrimineerimine tööturul või ebapiisavad muutuvad andmed",
        choiceB : "Need tegurid on teadmata",
        choiceC : "Tegurid, mis varieeruvad olenevalt ettevõttest",
        correct : "A"
    },{
        question : "Lisaks üldisele palgaerinevusele mõjutab sooline palgalõhe veel ka näiteks... ",
        imgSrc : "img/woman.jpeg",
        choiceA : "Laenu või liisingu võtmist",
        choiceB : "Töötukassalt toetuse saamist",
        choiceC : "Pensioni ja vanema- ning töötuskindlustushüvitist",
        correct : "C"
    },{
        question : "Kuidas mõjutab miinimumpalk soolist palgalõhet?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Tööandja ei ole kohustatud maksma rohkem palka, kui on määratud miinimumpalk.",
        choiceB : "Madalama palgaga ametitel väiksem sooline palgalõhe, kuna on määratud riiklikult madalaim tase, millest vähem ei saa palka maksta. ",
        choiceC : "Miinimumpalga sätestamisel ei ole mõju soolisele palgalõhele, kuna palgalõhe on ainult kõrgemapalgalistel ametikohtadel. ",
        correct : "B"
    },{
		//#10
        question : "Kus on Euroopa Liidu statistika järgi meeste ja naiste tööhõive sama kõrge ehk töötab sama protsent mehi ja naisi?",
        imgSrc : "img/woman.jpeg",
        choiceA : "See on väikseim Põhjamaades (Soomes, Norras ja Rootsis)",
        choiceB : "See on väikseim Kesk-Euroopas (Poolas ja Saksamaal)",
        choiceC : "See pm väikseim Suurbritannias",
        correct : "A"
    },{
        question : "Kuidas mõjutab pikendatud karjääripaus või lapsepuhkus naise palka võrreldes mehega?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Kui naine on lapsepuhkusel, siis enda positsioonile naastes on mees juba palgast lähtudes kaugemale jõudnud. ",
        choiceB : "Naine saab lapsepuhkuselt naastes sama palka, mis samal positsioonid töötav mees.",
        choiceC : "Naisele makstakse palka kodumajapidamistööde tegemise eest",
        correct : "A"
    },{
        question : "Mitu protsenti töötavatest naistest kuuluvad enim makstud töötajate hulka?",
        imgSrc : "img/woman.jpeg",
        choiceA : "6%",
        choiceB : "4%",
        choiceC : "13%",
        correct : "A"
    },{
        question : "2017. aasta seisuga on Euroopa kõige suurem palgalõhe…",
        imgSrc : "img/woman.jpeg",
        choiceA : "Eestis",
        choiceB : "Saksamaal",
        choiceC : "Poolas",
        correct : "A"
    },{
        question : "Kõige suurema tõenäosusega palgalõhet soodustav tegur:",
        imgSrc : "img/woman.jpeg",
        choiceA : "Naiste huvi puudulikkust antud teemast",
        choiceB : "Juhtivatel ja vastutavatel kohtadel töötavad peamiselt mehed",
        choiceC : "Naised teenivad vähem, sest nad valivad madalama palgaga töö",
        correct : "B"
    },{
		//#15
        question : "Mis on sooline palgalõhe?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Sooline palgalõhe on kogu majanduses esinev erinevus meeste ja naiste brutotunnitasus",
        choiceB : "Sooline palgalõhe on kogu majanduses esinev erinevus meeste ja naiste netotunnitasus",
        choiceC : "Sooline palgalõhe on kogu majanduses esinev meeste ja naiste töövõimekuse erinevus",
        correct : "A"
    },{
        question : "Kui suur on Euroopa Liidus üldine sooline palgalõhe 2019. aasta seisuga?",
        imgSrc : "img/woman.jpeg",
        choiceA : "9%",
        choiceB : "14%",
        choiceC : "16%",
        correct : "C"
    },{
        question : "Kui palju on naiste pension meeste keskmisest pensionist madalam?",
        imgSrc : "img/woman.jpeg",
        choiceA : "35%",
        choiceB : "40%",
        choiceC : "45%",
        correct : "B"
    },{
        question : "Tänapäeval on Euroopas 60% kõrghariduse omandanutest inimestest...",
        imgSrc : "img/woman.jpeg",
        choiceA : "Naised",
        choiceB : "Mehed",
        choiceC : "Vale, seis on võrdne",
        correct : "A"
    },{
        question : "Kui suur on meeste tõenäosus võrreldes naistega jõuda karjääri keskpaigaks juhtivale kohale?",
        imgSrc : "img/woman.jpeg",
        choiceA : "70%",
        choiceB : "65%",
        choiceC : "40%",
        correct : "A"
    },{
		//#20
        question : "Jeemenis, Süürias ja Iraagis on kõige suuremad palgalõhed. Mitu protsenti teenivad naised meestest vähem?",
        imgSrc : "img/woman.jpeg",
        choiceA : "30%",
        choiceB : "20%",
        choiceC : "50%",
        correct : "A"
    },{
        question : "Kui palju on Eesti juhtival positsioonil olevaid naisi (2017. aasta seisuga)?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Kümnest juhist 2",
        choiceB : "Kümnest juhist 4",
        choiceC : "Kümnest juhist 3,5",
        correct : "A"
    },{
        question : "Mis piirkonnad kannatavad soolise palgalõhe all?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Aasia",
        choiceB : "Euroopa",
        choiceC : "Kogu maailm",
        correct : "C"
    },{
        question : "Sooline palgalõhe on protsentuaalselt naiste hulgas suurem …",
        imgSrc : "img/woman.jpeg",
        choiceA : "Naiste vanuse kasvades",
        choiceB : "Nooremate naiste hulgas",
        choiceC : "Keskmiselt on naiste palgalõhe protsent läbivalt sama, olenemata nende vanusest",
        correct : "A"
    },{
        question : "Soolise palgalõhe protsent näitab …",
        imgSrc : "img/woman.jpeg",
        choiceA : "Naiste diskrimineerituse suurust",
        choiceB : "Naiste palga ebavõrdsust võrreldes meestega",
        choiceC : "Naiste töövõimekust",
        correct : "B"
    },{
		//#25
        question : "Enamustes riikides on sooline palgalõhe viimastel aastakümnetel …",
        imgSrc : "img/woman.jpeg",
        choiceA : "Püsinud muutumatuna",
        choiceB : "Suurenenud",
        choiceC : "Vähenenud",
        correct : "C"
    },{
        question : "Millises riigis on maailmas väikseim soolise palgalõhe protsent?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Laoses",
        choiceB : "Eestis",
        choiceC : "Taanis",
        correct : "A"
    },{
        question : "Mis aastaks võrdsustub sooline palgaerinevus prognooside kohaselt?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Aastaks 2024",
        choiceB : "Aastaks 2236",
        choiceC : "Aastaks 2461",
        correct : "B"
    },{
        question : "Milline oli esimene riik maailmas, kes viis sooliselt võrdse palga nõude sisse seadusandlusesse?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Kanada",
        choiceB : "Singapur",
        choiceC : "Island",
        correct : "C"
    },{
        question : "Kui palju kulutavad töötavad naised tasustamata majapidamistöödele nädalas?",
        imgSrc : "img/woman.jpeg",
        choiceA : "22 tundi",
        choiceB : "9 tundi",
        choiceC : "14 tundi",
        correct : "A"
    },{
		//#30
        question : "Miks on mehed kõrgematel positsioonidel ja saavad kõrgemat palka?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Põhjus on tööandja majanduslikus mõtlemises",
        choiceB : "Põhjus on kandideerimisprotsessis ja palgaootustes",
        choiceC : "Põhjus on töötaja pädevuses",
        correct : "B"
    },{
        question : "Mitut ettevõtet juhivad naised New Yorki 500 suurima börsiettevõtte hulgas?",
        imgSrc : "img/woman.jpeg",
        choiceA : "114 ettevõtet",
        choiceB : "2 ettevõtet",
        choiceC : "26 ettevõtet",
        correct : "C"
    },{
        question : "Mitu protsenti soolisest palgalõhest on täna seletamatu?",
        imgSrc : "img/woman.jpeg",
        choiceA : "36%",
        choiceB : "32%",
        choiceC : "24%",
        correct : "A"
    },{
        question : "Mitu protsenti üksikvanematest on Eestis naised?",
        imgSrc : "img/woman.jpeg",
        choiceA : "55%",
        choiceB : "74%",
        choiceC : "91%",
        correct : "C"
    },{
        question : "Millises Euroopa riigis on 2019 a. seisuga palgalõhe kõige väiksem?",
        imgSrc : "img/woman.jpeg",
        choiceA : "Saksamaa",
        choiceB : "Rumeenia",
        choiceC : "Inglismaa",
        correct : "B"
    },{
		//#35
        question : "Millises Eesti maakonnas on palgalõhe kõige suurem? (27,9%)",
        imgSrc : "img/woman.jpeg",
        choiceA : "Harjumaa",
        choiceB : "Võrumaa",
        choiceC : "Ida-Virumaa",
        correct : "C"
    },{
        question : "Millises Eesti maakonnas on palgalõhe kõige väiksem? (11,3%)",
        imgSrc : "img/woman.jpeg",
        choiceA : "Saaremaa",
        choiceB : "Tartumaa",
        choiceC : "Raplamaa",
        correct : "A"
    },{
        question : "Mehed on nõus uue töö vastu võtma keskmiselt 914 eurose brutopalga eest. Mis on see number naiste puhul?",
        imgSrc : "img/woman.jpeg",
        choiceA : "670 €",
        choiceB : "856 €",
        choiceC : "729€",
        correct : "C"
    },{
        question : "Kas Eestis on palgalõhe viimaste aastakümnetega...",
        imgSrc : "img/woman.jpeg",
        choiceA : "Kasvanud",
        choiceB : "Vähenenud",
        choiceC : "Jäänud enam vähem samale tasemele",
        correct : "B"
    },{
        question : "Kaua peaks Eestis naine keskmist tunnipalka arvestades sama aastapalga väljateenimiseks tegema Eesti mehest kauem tööd?",
        imgSrc : "img/woman.jpeg",
        choiceA : "1 kuu",
        choiceB : "3 kuud",
        choiceC : "4 kuud",
        correct : "B"
    },{
		//#40
        question : "Kas palgalõhe on suurem..",
        imgSrc : "img/woman.jpeg",
        choiceA : "Erasektoris",
        choiceB : "Avalikus sektoris",
        choiceC : "Mõlema puhul on sama suur",
        correct : "A"
    },{
        question : "Oodatava töötasu lõhe Eestis on kõige suurem millise haridustaseme puhul? (39,4%)",
        imgSrc : "img/woman.jpeg",
        choiceA : "Kõrgharidus",
        choiceB : "Keskharidus",
        choiceC : "Põhiharidus",
        correct : "C"
    },{
        question : "Kas oodatava töötasu lõhe on suurem..",
        imgSrc : "img/woman.jpeg",
        choiceA : "Vallaliste naiste puhul",
        choiceB : "Abielus naiste puhul",
        choiceC : "Perekonnaseis ei oma tähtsust",
        correct : "B"
    }
];

// create some variables
const lastQuestion = 14;
//const lastQuestion = questions.length - 1;
let runningQuestion = 0;
let count = 20;
const questionTime = 20; // 20s
const gaugeWidth = 150; // 150px
const gaugeUnit = gaugeWidth / count;
let TIMER;
let score = 0;
let limit = 43;
let randoms = [];
let questionCount = 0;

// prevent inspecting
document.addEventListener('contextmenu', function(e) {
	e.preventDefault();
});

document.onkeydown = function(e) {
	if(event.keyCode == 123) {
		return false;
	}
	if(e.ctrlKey && e.shiftKey && e.keyCode == 'I'.charCodeAt(0)) {
		return false;
	}
	if(e.ctrlKey && e.shiftKey && e.keyCode == 'C'.charCodeAt(0)) {
		return false;
	}
	if(e.ctrlKey && e.shiftKey && e.keyCode == 'J'.charCodeAt(0)) {
		return false;
	}
	if(e.ctrlKey && e.keyCode == 'U'.charCodeAt(0)) {
		return false;
	}
}

// render a question
function renderQuestion() {

	while (randoms.length < limit) {
		let random = Math.floor(Math.random() * 43);
		if (randoms.indexOf(random) == -1) {
			randoms.push(random);
		}
	}
	//console.log(questionCount);
	//console.log(randoms);
	//console.log("q = questions["+randoms[questionCount]+"]");
	let q = questions[randoms[questionCount]];
	
	choiceA.style.backgroundColor = "white";
	choiceB.style.backgroundColor = "white";
	choiceC.style.backgroundColor = "white";
    
    question.innerHTML = "<p>"+ q.question +"</p>";
    qImg.innerHTML = "<img src="+ q.imgSrc +">";
    choiceA.innerHTML = q.choiceA;
    choiceB.innerHTML = q.choiceB;
    choiceC.innerHTML = q.choiceC;
	//choiceD.innerHTML = q.choiceD;
}

start.addEventListener("click",startQuiz);

// start quiz
function startQuiz() {
    start.style.display = "none";
	ELRF.style.display = "none";
	ELU.style.display = "none";
	TLU.style.display = "none";
	REGE.style.display = "none";
	mainTitle.style.display = "none";
	info1.style.display = "none";
    renderQuestion();
    quiz.style.display = "block";
    renderProgress();
    renderCounter();
    TIMER = setInterval(renderCounter,1000); // 1000ms = 1s
}

// restart quiz
function restartQuiz() {
	start.style.display = "block";
	ELRF.style.display = "block";
	ELU.style.display = "block";
	TLU.style.display = "block";
	REGE.style.display = "block";
	mainTitle.style.display = "block";
	info1.style.display = "block";
	info2.style.display = "none";
	quiz.style.display = "none";
	scoreDiv.style.display = "none";
	restart.style.display = "none";
	runningQuestion = 0;
	questionCount = 0;
	count = 20;
	score = 0;
	randoms = [];
	progress.innerHTML = null;
}

// resume quiz
function resumeQuiz() {
	questionCount++;
	enableChoices();
	renderQuestion();
	renderCounter();
	next.style.display = "none";
	TIMER = setInterval(renderCounter,1000); // 1000ms = 1s
}

// disable choices
function disableChoices() {
	choiceA.disabled = true;
	choiceA.style.color = "gray";
	choiceB.disabled = true;
	choiceB.style.color = "gray";
	choiceC.disabled = true;
	choiceC.style.color = "gray";
	//choiceD.disabled = true;
	//choiceD.style.color = "gray";
}

// enable choices
function enableChoices() {
	choiceA.disabled = false;
	choiceA.style.color = "black";
	choiceB.disabled = false;
	choiceB.style.color = "black";
	choiceC.disabled = false;
	choiceC.style.color = "black";
	//choiceD.disabled = false;
	//choiceD.style.color = "black";
}

// render progress
function renderProgress() {
    for(let qIndex = 0; qIndex <= lastQuestion; qIndex++){
        progress.innerHTML += "<div class='prog' id="+ qIndex +"></div>";
    }
}

// counter render
function renderCounter() {
    if(count != -1){
        counter.innerHTML = count;
        timeGauge.style.width = count * gaugeUnit + "px";
        count--;
    }else{
        count = 20;
        // change progress color to red
        answerIsWrong();
        if(runningQuestion < lastQuestion){
            runningQuestion++;
			questionCount++;
            renderQuestion();
        }else{
            // end the quiz and show the score
            clearInterval(TIMER);
            scoreRender();
        }
    }
}

// checkAnwer

function checkAnswer(answer) {
	//console.log("answer = " + answer);
	//console.log("randoms[questionCount] = " + randoms[questionCount]);
	//console.log("questions[randoms[questionCount]].correct = " + questions[randoms[questionCount]].correct);
	
    if( answer == questions[randoms[questionCount]].correct){
        // answer is correct
		rightAnswer = document.getElementById(answer)
		rightAnswer.style.backgroundColor = "#99FF99";
        score++;
        // change progress color to green
        answerIsCorrect();
    }else{
        // answer is wrong
        // change progress color to red
		wrongAnswer = document.getElementById(answer)
		wrongAnswer.style.backgroundColor = "#FF6666";
		rightAnswer = document.getElementById(questions[randoms[questionCount]].correct)
		rightAnswer.style.backgroundColor = "#99FF99";
        answerIsWrong();
    }
    count = 20;
    if(runningQuestion < lastQuestion){
        runningQuestion++;
		next.style.display = "block";
		disableChoices();
		clearInterval(TIMER);
    }else{
        // end the quiz and show the score
        clearInterval(TIMER);
        scoreRender();
    }
}

// answer is correct
function answerIsCorrect() {
    document.getElementById(runningQuestion).style.backgroundColor = "#0f0";
}

// answer is Wrong
function answerIsWrong() {
    document.getElementById(runningQuestion).style.backgroundColor = "#f00";
}

// score render
function scoreRender() {
    scoreDiv.style.display = "block";
    restart.style.display = "block";
	info2.style.display = "block";
	
    // calculate the amount of question percent answered by the user
    const scorePerCent = Math.round(100 * score/14);
    
    // choose the image based on the scorePerCent
    let img = (scorePerCent >= 80) ? "img/5.png" :
              (scorePerCent >= 60) ? "img/4.png" :
              (scorePerCent >= 40) ? "img/3.png" :
              (scorePerCent >= 20) ? "img/2.png" :
              "img/1.png";
    
    scoreDiv.innerHTML = "<img src="+ img +">";
    scoreDiv.innerHTML += "<p>"+ scorePerCent +"%</p>";
	/*restart.style.display = "block";
	restart.addEventListener("click", restartQuiz);*/
}